commit 59f3803357d9f6b166b69c0bcf9f948b82872a2f
Author: Eric Botcazou <ebotcazou@adacore.com>
Date:   Fri Sep 11 10:41:28 2020 +0200

    Fix crash on array component with nonstandard index type
    
    This is a regression present on mainline, 10 and 9 branches: the compiler
    goes into an infinite recursion eventually exhausting the stack for the
    declaration of a discriminated record type with an array component having
    a discriminant as bound and an index type that is an enumeration type with
    a non-standard representation clause.
    
    gcc/ada/ChangeLog:
            * gcc-interface/decl.c (gnat_to_gnu_entity) <E_Array_Subtype>: Only
            create extra subtypes for discriminants if the RM size of the base
            type of the index type is lower than that of the index type.
    
    gcc/testsuite/ChangeLog:
            * gnat.dg/specs/discr7.ads: New test.

diff --git a/gcc/ada/gcc-interface/decl.c b/gcc/ada/gcc-interface/decl.c
index ef72ecf1829..599b7d33701 100644
--- a/gcc/ada/gcc-interface/decl.c
+++ b/gcc/ada/gcc-interface/decl.c
@@ -2453,8 +2453,8 @@ gnat_to_gnu_entity (Entity_Id gnat_entity, tree gnu_expr, bool definition)
 	      tree gnu_base_orig_max = TYPE_MAX_VALUE (gnu_base_index_type);
 	      tree gnu_min, gnu_max, gnu_high;
 
-	      /* We try to define subtypes for discriminants used as bounds
-		 that are more restrictive than those declared by using the
+	      /* We try to create subtypes for discriminants used as bounds
+		 that are more restrictive than those declared, by using the
 		 bounds of the index type of the base array type.  This will
 		 make it possible to calculate the maximum size of the record
 		 type more conservatively.  This may have already been done by
@@ -2462,8 +2462,8 @@ gnat_to_gnu_entity (Entity_Id gnat_entity, tree gnu_expr, bool definition)
 		 there will be a conversion that needs to be removed first.  */
 	      if (CONTAINS_PLACEHOLDER_P (gnu_orig_min)
 		  && TYPE_RM_SIZE (gnu_base_index_type)
-		  && !tree_int_cst_lt (TYPE_RM_SIZE (gnu_index_type),
-				       TYPE_RM_SIZE (gnu_base_index_type)))
+		  && tree_int_cst_lt (TYPE_RM_SIZE (gnu_base_index_type),
+				      TYPE_RM_SIZE (gnu_index_type)))
 		{
 		  gnu_orig_min = remove_conversions (gnu_orig_min, false);
 		  TREE_TYPE (gnu_orig_min)
@@ -2474,8 +2474,8 @@ gnat_to_gnu_entity (Entity_Id gnat_entity, tree gnu_expr, bool definition)
 
 	      if (CONTAINS_PLACEHOLDER_P (gnu_orig_max)
 		  && TYPE_RM_SIZE (gnu_base_index_type)
-		  && !tree_int_cst_lt (TYPE_RM_SIZE (gnu_index_type),
-				       TYPE_RM_SIZE (gnu_base_index_type)))
+		  && tree_int_cst_lt (TYPE_RM_SIZE (gnu_base_index_type),
+				      TYPE_RM_SIZE (gnu_index_type)))
 		{
 		  gnu_orig_max = remove_conversions (gnu_orig_max, false);
 		  TREE_TYPE (gnu_orig_max)
diff --git a/gcc/testsuite/gnat.dg/specs/discr7.ads b/gcc/testsuite/gnat.dg/specs/discr7.ads
new file mode 100644
index 00000000000..ca35ced2e7a
--- /dev/null
+++ b/gcc/testsuite/gnat.dg/specs/discr7.ads
@@ -0,0 +1,14 @@
+-- { dg-do compile }
+
+package Discr7 is
+
+  type Enum is (One, Two, Three);
+  for Enum use (One => 1, Two => 2, Three => 3);
+
+  type Arr is array (Integer range <>, Enum range <>) of Boolean;
+
+  type Rec (D : Integer) is record
+    A: Arr (1 .. D, Enum'Range);
+  end record;
+
+end Discr7;

